//[module]	SSBUSC
//[processor]	IOP
//[type]	ELF-IRX
//[size]	1897(0x769)
//[bios]	10000(0x26400-0x26B70)
//[iopboot]	05
//[name]	ssbus_service
//[version]	0x101
//[memory map]	0xBF801000,0xBF801004,0xBF801008,0xBF80100C,		(r/w)
//		0xBF801010,0xBF801014,0xBF801018,0xBF80101C,0xBF801020	(r/w)
//		0xBF801400,0xBF801404,0xBF801408,0xBF80140C,		(r/w)
//		0xBF801410,0xBF801414,0xBF801418,0xBF80141C,0xBF801420	(r/w)
//[handlers]	-
//[entry point]	start, export_stub
//[made by]	[RO]man (roman_ps2dev@hotmail.com)

#include "..\include\loadcore.h"	//(0x101,RegisterLibraryEntries)
#include "..\include\intrman.h"		//(0x102,CpuSuspendIntr,CpuResumeIntr)

int memmap_table[]={
	0xBF801008, 0xBF80100C, 0xBF801010, 	     0, 0xBF801014,//spu_delay
	0xBF801018,	     0,		 0, 0xBF80101C, 0xBF801414,
	0xBF801418, 0xBF80141C, 0xBF801420
};

int memmap_table_2[]={
	0xBF801000, 0xBF801400,		 0,	     0, 0xBF801404,
	0xBF801408,	     0,		 0, 0xBF801004, 0xBF80140C,
		 0, 0xBF801410,		 0
};

int start();
int return_0();
int ssbusc_call4(int code, int value);
int ssbusc_call5(int code);
int ssbusc_call6(int code, int value);
int ssbusc_call7(int code);
int ssbusc_call8(int a);
int ssbusc_call9();
int ssbusc_call10(int a);
int ssbusc_call11();
int ssbusc_call12(int a);
int ssbusc_call13();
int ssbusc_call14(int a);
int ssbusc_call15();
int ssbusc_call16(int a);
int ssbusc_call17();
void retonly();

//////////////////////////////entrypoint///////////////////////////////
struct export export_stub={
	0x41C00000,
	0,
	VER(1, 1),	// 1.1 => 0x101
	0,
	"ssbusc",
	(func)start,	// entrypoint
	(func)retonly,
	(func)return_0,
	(func)retonly,
	(func)ssbusc_call4,
	(func)ssbusc_call5,
	(func)ssbusc_call6,
	(func)ssbusc_call7,
	(func)ssbusc_call8,
	(func)ssbusc_call9,
	(func)ssbusc_call10,
	(func)ssbusc_call11,
	(func)ssbusc_call12,
	(func)ssbusc_call13,
	(func)ssbusc_call14,
	(func)ssbusc_call15,
	(func)ssbusc_call16,
	(func)ssbusc_call17,
	0		// end of list
};

//////////////////////////////entrypoint///////////////////////////////
int start(){
    int x;

	CpuSuspendIntr(&x);					//intrman
	if (RegisterLibraryEntries(&export_stub)==0){		//loadcore
		CpuResumeIntr(x);				//intrman
		return 0;
	}else{
		CpuResumeIntr(x);				//intrman
		return 1;
	}
}

///////////////////////////////////////////////////////////////////////
int return_0(){
	return 0;
}

///////////////////////////////////////////////////////////////////////
int ssbusc_call4(int code, int value){			//set
    int *v;
	if ((code < 13) && (v=memmap_table[code]))
		return *v=value;
	return -1;
}

///////////////////////////////////////////////////////////////////////
int ssbusc_call5(int code){				//get
    int *v;
	if ((code < 13) && (v=memmap_table[code]))
		return *v;
	return -1;
}

///////////////////////////////////////////////////////////////////////
int ssbusc_call6(int code, int value){			//set
    int *v;
	if ((code < 13) && (v=memmap_table_2[code]))
		return *v=value;
	return -1;
}

///////////////////////////////////////////////////////////////////////
int ssbusc_call7(int code){				//get
    int *v;
	if ((code < 13) && (v=memmap_table_2[code]))
		return *v;
	return -1;
}

///////////////////////////////////////////////////////////////////////
int ssbusc_call8(int a){				//set lowest nibble
	return	 *(int*)(0xBF801020) = 
		(*(int*)(0xBF801020) & 0xFFFFFFF0) |
		(             a      &        0xF);
}

///////////////////////////////////////////////////////////////////////
int ssbusc_call9(){					//get lowest nibble
	return   *(int*)(0xBF801020) &        0xF;
}

///////////////////////////////////////////////////////////////////////
int ssbusc_call10(int a){					//set
	return	 *(int*)(0xBF801020) = 
		(*(int*)(0xBF801020) & 0xFFFFFF0F) |
		(         (a << 4)   &       0xF0);
}

///////////////////////////////////////////////////////////////////////
int ssbusc_call11(){						//get
	return *(unsigned char*)(0xBF801020) >> 4;
}

///////////////////////////////////////////////////////////////////////
int ssbusc_call12(int a){					//set
	return	 *(int*)(0xBF801020) = 
		(*(int*)(0xBF801020) & 0xFFFFF0FF) |
		(         (a << 8)   &      0xF00);
}

///////////////////////////////////////////////////////////////////////
int ssbusc_call13(){						//get
	return  (*(int*)(0xBF801020) >> 8) & 0xF;
}

///////////////////////////////////////////////////////////////////////
int ssbusc_call14(int a){					//set
	return	 *(int*)(0xBF801020) = 
		(*(int*)(0xBF801020) & 0xFFFF0FFF) |
		(        (a << 12)   &     0xF000);
}

///////////////////////////////////////////////////////////////////////
int ssbusc_call15(){						//get
	return  (*(int*)(0xBF801020) >> 12) & 0xF;
}

///////////////////////////////////////////////////////////////////////
int ssbusc_call16(int a){					//set
	return   *(int*)(0xBF801020) = a;
}

///////////////////////////////////////////////////////////////////////
int ssbusc_call17(){						//get
	return   *(int*)(0xBF801020);
}

///////////////////////////////////////////////////////////////////////
void retonly(){}

